hdu3415——Max Sum of Max-K-sub-sequence

Max Sum of Max-K-sub-sequence

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 6130    Accepted Submission(s): 2234

Problem Description

Given a circle sequence A[1],A[2],A[3]......A[n]. Circle sequence means the left neighbour of A[1] is A[n] , and the right neighbour of A[n] is A[1].

Now your job is to calculate the max sum of a Max-K-sub-sequence. Max-K-sub-sequence means a continuous non-empty sub-sequence which length not exceed K.

Input

The first line of the input contains an integer T(1<=T<=100) which means the number of test cases.

Then T lines follow, each line starts with two integers N , K(1<=N<=100000 , 1<=K<=N), then N integers followed(all the integers are between -1000 and 1000).

Output

For each test case, you should output a line contains three integers, the Max Sum in the sequence, the start position of the sub-sequence, the end position of the sub-sequence. If there are more than one result, output the minimum
start position, if still more than one , output the minimum length of them.

Sample Input

4
6 3
6 -1 2 -6 5 -5
6 4
6 -1 2 -6 5 -5
6 3
-1 2 -6 5 -5 6
6 6
-1 -1 -1 -1 -1 -1

Sample Output

7 1 3
7 1 3
7 6 2
-1 1 1

Author

shǎ崽@HDU

Source

HDOJ Monthly Contest – 2010.06.05

Recommend

lcy   |   We have carefully selected several similar problems for you:  3423 3417 3418 3419 3421

先把环变成链,然后就是在1 - 2 * n - 1之间求

求出前缀和,那么ans = max(sum[i] - sum[j - 1])而且 i - j + 1 <=k

用一个单调队列来维护sum[j - 1],边维护边记录答案

PS:这题应该还能用线段树,RMQ等方法解决

#include <map>
#include <set>
#include <list>
#include <queue>
#include <stack>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = 200010;

int dp[N], arr[N];
int in_que[N], sum[N];

int main()
{
	int n, t, k;
	scanf("%d", &t);
	while (t--)
	{
		scanf("%d%d", &n, &k);
		sum[0] = 0;
		for (int i = 1; i <= n; ++i)
		{
			scanf("%d", &arr[i]);
			sum[i] = sum[i - 1] + arr[i];
		}
		for (int i = n + 1; i < 2 * n; ++i)
		{
			sum[i] = sum[i - 1] + arr[i - n];
		}
		int front = 0, rear = 0;
		int s, e, maxs = -0x3f3f3f3f;
		for (int i = 1; i <= k; ++i)
		{

			while (front < rear && sum[in_que[rear - 1]] >= sum[i - 1])
			{
				rear--;
			}
			in_que[rear++] = i - 1;
			// printf("%d %d\n", sum[in_que[front]], sum[i]);
			if (maxs < sum[i] - sum[in_que[front]])
			{
				maxs = sum[i] - sum[in_que[front]];
				s = in_que[front] + 1;
				e = i;
			}
			else if (maxs == sum[i] - sum[in_que[front]] && in_que[front] + 1 < s)
			{
				s = in_que[front] + 1;
			}
			else if (maxs == sum[i] - sum[in_que[front]] && in_que[front] + 1 == s && e > i)
			{
				e = i;
			}
			// printf("%d\n", in_que[front]);
		}
		for (int i = k + 1; i < 2 * n; ++i)
		{
			while (front < rear && sum[in_que[rear - 1]] >= sum[i - 1])
			{
				rear--;
			}
			in_que[rear++] = i - 1;
			if (in_que[front] < i - k)
			{
				front++;
			}
			if (maxs < sum[i] - sum[in_que[front]])
			{
				maxs = sum[i] - sum[in_que[front]];
				s = in_que[front] + 1;
				e = i;
			}
			else if (maxs == sum[i] - sum[in_que[front]] && in_que[front] + 1 < s)
			{
				s = in_que[front] + 1;
			}
			else if (maxs == sum[i] - sum[in_que[front]] && in_que[front] + 1 == s && e > i)
			{
				e = i;
			}
		}
		if (s > n)
		{
			s -= n;
		}
		if (e > n)
		{
			e -= n;
		}
		printf("%d %d %d\n", maxs, s, e);
	}
	return 0;
}
时间: 2024-08-24 17:49:59

hdu3415——Max Sum of Max-K-sub-sequence的相关文章

HDU 1003 Max Sum(dp,最大连续子序列和)

Max Sum Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input

HDU 1003.Max Sum【最大连续子序列和】【8月14】

Max Sum Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input

POJ 1003 Max Sum

Max Sum Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input

hdu3415 Max Sum of Max-K-sub-sequence 单调队列

//hdu3415 Max Sum of Max-K-sub-sequence //单调队列 //首先想到了预处理出前缀和利用s[i] - s[j]表示(j,i]段的和 //之后的问题就转换成了求一个最小的s[j]了,这样就能够单调队列 //求最小值. //队列中维护的是区间的開始的位置j.我们插入队列中的是j-1,由于 //这个时候s[i] - s[j-1]刚好就是[j,i]段闭区间的和 //这里用两种方式实现,一种是stl,一种是手动模拟,两者的速度,測试的 //结果在杭电測试都是一样的,4

K - Max Sum Plus Plus

K - Max Sum Plus Plus Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Description Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more diffi

Leetcode: Max Sum of Rectangle No Larger Than K

Given a non-empty 2D matrix matrix and an integer k, find the max sum of a rectangle in the matrix such that its sum is no larger than k. Example: Given matrix = [ [1, 0, 1], [0, -2, 3] ] k = 2 The answer is 2. Because the sum of rectangle [[0, 1], [

【leetcode】363. Max Sum of Rectangle No Larger Than K

题目描述: Given a non-empty 2D matrix matrix and an integer k, find the max sum of a rectangle in the matrix such that its sum is no larger than k. 解题思路: 根据题意,寻找二维数组中所有可以组成的矩形中面积不超过k的最大值,所以必须要求出可能组成的矩形的面积并与k比较求出最终结果.这里为了最终不超时,可以在一下方面进行优化: 1.设置一个数组比较当前列(或

[LeetCode] Max Sum of Rectangle No Larger Than K 最大矩阵和不超过K

Given a non-empty 2D matrix matrix and an integer k, find the max sum of a rectangle in the matrix such that its sum is no larger than k. Example: Given matrix = [ [1, 0, 1], [0, -2, 3] ] k = 2 The answer is 2. Because the sum of rectangle [[0, 1], [

363 Max Sum of Rectangle No Larger Than K 最大矩阵和不超过K

Given a non-empty 2D matrix matrix and an integer k, find the max sum of a rectangle in the matrix such that its sum is no larger than k.Example:Given matrix = [  [1,  0, 1],  [0, -2, 3]]k = 2The answer is 2. Because the sum of rectangle [[0, 1], [-2